class_name PlayerHUD extends Control

@onready var interact_hud: InteractHUD = %InteractHUD

@onready var grunk_alert_player: AnimationPlayer = %GrunkAlertPlayer
@onready var tank_alert_player: AnimationPlayer = %TankAlertPlayer
@onready var alert_clear_player: AnimationPlayer = %AlertClearPlayer


func _ready() -> void:
	World.instance.manager.alert_raised.connect(_on_raise_alert)
	World.instance.manager.alert_cleared.connect(_on_clear_alert)


func select_interactive(prop: Interactive) -> void:
	interact_hud.set_prop(prop)


func _on_raise_alert(_new_value: int) -> void:
	grunk_alert_player.play("grunk_alert")


func play_tank_full_alert() -> void:
	tank_alert_player.play("tank_full_alert")


func _on_clear_alert() -> void:
	alert_clear_player.play("alert_clear")
