@tool
class_name UpdateStalkingTarget extends ActionLeaf
## Copy the pursuit target to the stalking target during pursuit.

const SOURCE_KEY := "pursuit_target"
const DEST_KEY := "stalking_target"

@onready var stalking_timer: Timer = %StalkingTimer


func tick(_actor: Node, blackboard: Blackboard) -> int:
	@warning_ignore("unsafe_cast")
	var target := blackboard.get_value(SOURCE_KEY) as Node3D
	if not is_instance_valid(target):
		return FAILURE
	blackboard.set_value(DEST_KEY, target.global_position)
	stalking_timer.start()
	return SUCCESS
